commit fd9f0b7354ffc2986f0b2e7b074117feb29b5102
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sat Aug 13 20:19:16 2022 +0100

    Partial workaround for TCP Fast Open issue.  Bug 2907

diff --git a/src/src/smtp_out.c b/src/src/smtp_out.c
index 7b7bdf752..7f364d942 100644
--- a/src/src/smtp_out.c
+++ b/src/src/smtp_out.c
@@ -372,7 +372,7 @@ if (!save_errno)
 # ifdef TCP_FASTOPEN_CONNECT
     else
       {						/* expecting client data */
-      debug_printf(" set up lazy-connect\n");
+      DEBUG(D_transport|D_acl|D_v) debug_printf(" set up lazy-connect\n");
       setsockopt(sock, IPPROTO_TCP, TCP_FASTOPEN_CONNECT, US &on, sizeof(on));
       /* fastopen_blob = NULL;		 lazy TFO, triggered by data write */
       }
diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index d7f251b0b..bbff1cad8 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -5312,6 +5312,17 @@ retry_non_continued:
     uschar *retry_message_key = NULL;
     uschar *serialize_key = NULL;
 
+    /* Deal slightly better with a possible Linux kernel bug that results
+    in intermittent TFO-conn fails deep into the TCP flow.  Bug 2907 tracks.
+    Hack: Clear TFO option for any further hosts on this tpt run. */
+
+    if (total_hosts_tried > 0)
+      {
+      DEBUG(D_transport|D_acl|D_v)
+	debug_printf("Clearing TFO as not first host for message\n");
+      ob->hosts_try_fastopen = US"";
+      }
+
     /* Default next host is next host. :-) But this can vary if the
     hosts_max_try limit is hit (see below). It may also be reset if a host
     address is looked up here (in case the host was multihomed). */

